Type: Package
Package: indiedown
Title: Individual R Markdown Templates
Version: 0.1.1
Authors@R: 
    c(person(given = "Christoph",
             family = "Sax",
             role = c("aut", "cre"),
             email = "christoph.sax@gmail.com",
             comment = c(ORCID = "0000-0002-7192-7044")),
      person(given = "Kirill",
             family = "Müller",
             role = "aut",
             comment = c(ORCID = "0000-0002-1416-3412")),
      person(given = "Angelica",
             family = "Becerra",
             role = "aut"),
      person(given = "Frederik",
             family = "Aust",
             role = "aut"),
      person(given = "cynkra GmbH",
             role = c("fnd", "cph"),
             email = "mail@cynkra.com"))
Description: Simplifies the generation of customized R Markdown PDF templates.
    A template may include an individual logo, typography, geometry or color
    scheme. The package provides a skeleton with detailed instructions for
    customizations. The skeleton can be modified by changing defaults in the
    'YAML' header, by adding additional 'LaTeX' commands or by applying dynamic
    adjustments in R. Individual corporate design elements, such as a title page, can be added as R functions that produce 'LaTeX' code.
License: MIT + file LICENSE
URL: https://cynkra.github.io/indiedown/,
        https://github.com/cynkra/indiedown
BugReports: https://github.com/cynkra/indiedown/issues
Depends: R (>= 4.0.0)
Imports: cli, fs, gfonts, rlang, withr
Suggests: callr, knitr (>= 1.12), rcmdcheck, rmarkdown, spelling,
        testthat (>= 3.0.0)
VignetteBuilder: knitr
Config/testthat/edition: 3
Encoding: UTF-8
Language: en-US
LazyData: TRUE
RoxygenNote: 7.1.1
NeedsCompilation: no
Packaged: 2021-03-21 08:49:06 UTC; christoph
Author: Christoph Sax [aut, cre] (<https://orcid.org/0000-0002-7192-7044>),
  Kirill Müller [aut] (<https://orcid.org/0000-0002-1416-3412>),
  Angelica Becerra [aut],
  Frederik Aust [aut],
  cynkra GmbH [fnd, cph]
Maintainer: Christoph Sax <christoph.sax@gmail.com>
Repository: CRAN
Date/Publication: 2021-03-22 15:30:06 UTC
Built: R 4.6.0; ; 2026-04-26 13:33:55 UTC; unix

Package: mypackage
Title: Acme Inc. Corporate Design R Markdown Template
Version: 0.1
Authors@R:
    person(given = "First",
           family = "Last",
           role = c("aut", "cre"),
           email = "first.last@example.com")
Description: Provides an R Markdown template conforming to the
    corporate design guidelines at Acme Inc.
License: file LICENSE
Depends:
    R (>= 4.0.0)
Imports:
    glue,
    knitr (>= 1.12),
    rmarkdown,
    utils,
    withr,
    yaml
Encoding: UTF-8
LazyData: true
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.1.1

<!-- README.md is generated from README.Rmd on GitHub Actions: do not edit by hand -->

# indiedown

Individual R Markdown PDF Templates.

<!-- badges: start -->

[![Lifecycle: experimental](https://img.shields.io/badge/lifecycle-experimental-orange.svg)](https://lifecycle.r-lib.org/articles/stages.html#experimental) [![R build status](https://github.com/cynkra/indiedown/workflows/rcc/badge.svg)](https://github.com/cynkra/indiedown/actions) [![Coverage status](https://codecov.io/gh/cynkra/indiedown/branch/main/graph/badge.svg)](https://codecov.io/github/cynkra/indiedown?branch=master) ![CRAN status](https://www.r-pkg.org/badges/version/indiedown)

<!-- badges: end -->

indiedown allows you to generate a customized R Markdown PDF template in a few basic steps.

Start by installing indiedown:

<pre class='chroma'>
<span class='nf'><a href='https://rdrr.io/r/utils/install.packages.html'>install.packages</a></span><span class='o'>(</span><span class='s'>"indiedown"</span><span class='o'>)</span></pre>

You can also install the development version from GitHub:

<pre class='chroma'>
<span class='c'># install.packages("devtools")</span>
<span class='nf'>devtools</span><span class='nf'>::</span><span class='nf'><a href='https://devtools.r-lib.org//reference/remote-reexports.html'>install_github</a></span><span class='o'>(</span><span class='s'>"cynkra/indiedown"</span><span class='o'>)</span></pre>

To create your own customized R Markdown template, start by creating an indiedown template package, called `mydown` in this example. Navigate to the directory where you want to create the package, then:

<pre class='chroma'>
<span class='nf'>indiedown</span><span class='nf'>::</span><span class='nf'><a href='https://cynkra.github.io/indiedown/reference/create_indiedown_package.html'>create_indiedown_package</a></span><span class='o'>(</span><span class='s'>"mydown"</span><span class='o'>)</span></pre>

This creates a package skeleton in the new `mydown` directory in the current working directory. You can build *mydown*, using “Build and Reload” in the RStudio or via the command line, as follows:

<pre class='chroma'>
<span class='nf'>devtools</span><span class='nf'>::</span><span class='nf'><a href='https://devtools.r-lib.org//reference/install.html'>install</a></span><span class='o'>(</span><span class='s'>"mydown"</span><span class='o'>)</span></pre>

With *mydown* built and installed, our new template is available in RStudio (after a restart).

-   Read more at `vignette("indiedown")`.
-   See `vignette("walkthrough")` for a step by step guide to customization.
-   See `vignette("customize")` for advanced customization.

------------------------------------------------------------------------

## Code of Conduct

Please note that the indiedown project is released with a [Contributor Code of Conduct](https://cynkra.github.io/indiedown/CODE_OF_CONDUCT.html). By contributing to this project, you agree to abide by its terms.

# Indiedown functionality, copied from indiedown
#
# do not customize this file!

indiedown_pdf_document_with_asset <- function(includes = NULL, ...) {

  # file preamble
  if (file.exists(file.path(indiedown_path(), "preamble.tex"))) {

    file_preamble <- tempfile(fileext = ".tex")
    txt <- readLines(file.path(indiedown_path(), "preamble.tex"), encoding = "UTF-8")
    txt <- gsub("<<indiedown_path>>", indiedown_path_tex(), txt, fixed = TRUE)
    writeLines(txt, file_preamble)

    if (is.null(includes)) {
      includes <- rmarkdown::includes(in_header = file_preamble)
    } else {
      if ("in_header" %in% names(includes)) {
        warning("The use of 'includes, in_header' overwrites preamble.tex from asset and may mess up the layout.")
      } else {
        includes$in_header <- file_preamble
      }
    }
  }

  ans <- rmarkdown::pdf_document(includes = includes, ...)

  # use pre_processor from asset package or pre_processor_basic, if not present
  file_pre_processor <- file.path(indiedown_path(), "pre_processor.R")
  if (file.exists(file_pre_processor)) {
    env <- environment()
    source(file.path(file_pre_processor), env)
    stopifnot(exists("pre_processor", envir = env))
  } else {
    pre_processor <- pre_processor_basic
  }

  ans$pre_processor <- pre_processor
  ans
}

pre_processor_basic <- function(metadata, input_file, runtime, knit_meta, files_dir, output_dir) {
  args <- apply_default_yaml(metadata = metadata)
}

apply_default_yaml <- function(metadata) {
  defaults_txt <- readLines(file.path(indiedown_path(), "default.yaml"), encoding = "UTF-8")

  # replace <<indiedown_path>> by package path
  defaults_txt <- gsub("<<indiedown_path>>", indiedown_path_tex(), defaults_txt, fixed = TRUE)

  defaults <- yaml::yaml.load(defaults_txt)

  # do not apply asset defaults if variable set in document
  defaults_applied <- defaults[setdiff(names(defaults), names(metadata))]

  args <- list_to_pandoc_args(defaults_applied)

  # pandoc ignores 'header-includes' if includes$in_header is specified
  # https://github.com/jgm/pandoc/issues/3139
  # we can still use `header-includes` by passing it as a command line option to pandoc
  if (!is.null(rmarkdown::metadata$`header-includes`)) {
    args <- c(args, "--variable", paste0("header-includes:", paste(rmarkdown::metadata$`header-includes`, collapse = "\n")))
  }

  args
}

# list <- list(
#   indent = TRUE,
#   `compact-title` = TRUE,
#   classoption = c("twocolumn", "landscape")
# )
# list_to_pandoc_args(list)
list_to_pandoc_args <- function(list) {
  is_logical <- vapply(list, is.logical, TRUE)
  is_character <- vapply(list, is.character, TRUE)

  # prepare logicals (TRUE FALSE to yes no)
  list[is_logical] <- lapply(list[is_logical], function(x) ifelse(x, "yes", "no"))
  # prepare character (comma separate multiple values)
  list[is_character] <- lapply(list[is_character], paste, collapse = ",")

  vars <- paste0(names(list), ":", unlist(list))

  zip <- function(x, y) {
    x <- rep_len(x, length(y))
    m <- matrix(c(x, y), nrow = 2, byrow = TRUE)
    as.vector(m)
  }
  zip("--variable", vars)
}

#' Path helpers
#'
#' `indiedown_path()` creates a path to this package's indiedown assets,
#' located at `inst/indiedown`.
#'
#' @param ... Path components, passed on to `system.file()`.
#' @return Character string, path to this package's indiedown assets
#' @examples
#' indiedown_path()
#' @export
indiedown_path <- function(...) {
  system.file("indiedown", ..., package = utils::packageName())
}

#' Path to indiedown assets, usable in LaTeX
#'
#' `indiedown_path_tex()` creates a path that is usable in LaTeX,
#' with all special characters escaped.
#'
#' @rdname indiedown_path
#' @export
indiedown_path_tex <- function(...) {
  sanitize_tex(indiedown_path(...))
}


sanitize_tex <- function(path) {
  # on win, tex does not like \\
  path <- gsub("\\", "/", fixed = TRUE, path)
  path <- gsub("~", "\\string~", path, fixed = TRUE)
  path
}

#' Glue LaTeX Code for Use in R Markdown
#'
#' Use the function to wrap literal LaTeX code in R. Use a raw string input
#' (`r"()"`) to automatically escape quotes and backslashes, as they are common
#' in LaTeX. Expressions enclosed by `<<` and `>>` will be evaluated as R code.
#'
#' `indiedown_glue()` uses a different default than the underlying
#' `glue::glue()` (`<<` and `>>`), because braces are so common in LaTeX.
#' Doubling the full delimiter (`<<<<` and `>>>>`) escapes it.
#'
#' @param x Character, often as a raw string (`r"()"`)
#' @param .open,.close The opening and closing delimiter.
#' @return Object of class `"knit_asis"` (so that knitr will treat it as is). Usually LaTeX code.
#' @export
#' @examples
#' x <- "something"
#' indiedown_glue(r"(\LaTeX\ code with <<x>> substituted )")
#'
indiedown_glue <- function(x, .open = "<<", .close = ">>") {
  ans <- glue::glue(x, .envir = sys.frame(-1), .open = .open, .close = .close)
  knitr::asis_output(ans)
}


# compatible with older versions. We can use raw strings from 4.0 on.
read_tex <- function(file) {
  paste(readLines(indiedown_path("tex", file), encoding = "UTF-8"), collapse = "\n")
}

#' Set Default Value
#'
#' Set default value of an argument. If `x` is `NULL`, `default` is used.
#'
#' @param x Character string, or `NULL`
#' @param default If `x` is `NULL`, `default` is used.
#'
#' @return Character string
#' @examples
#' default(NULL)
#' default(NULL, "my default")
#' default("a string", "my default")
#' @export
default <- function(x, default = "") {
  ans <- if (is.null(x)) default else x
  force(ans)
}

# indiedown: customize options to rmarkdown::pdf_document() here

#' Customized R Markdown Document
#'
#' `mypackage()` is the main function of the mypackage package. Use as
#' `output: mypackage::mypackage` in the R Markdown YAML header.
#'
#' @param ... Passed on to [rmarkdown::pdf_document()].
#' @return R Markdown output format to pass to [rmarkdown::render()].
#' @export
mypackage <- function(...) {
  indiedown_pdf_document_with_asset(
    highlight = "pygments",
    latex_engine = "lualatex",
    ...
  )
}

#' Corporate Design: Title Page
#'
#' Example function to generate a title page
#'
#' @param title Document title
#' @param subtitle Document subtitle
#' @param date Document creation date
#' @return Object of class `"knit_asis"` (so that knitr will treat it as is). LaTeX code for title page.
#' @export
#' @examples
#' cd_page_title(
#'   title = "My Title",
#'   subtitle = "My Subtitle"
#' )
cd_page_title <- function(title = default(rmarkdown::metadata$title, "Title"),
                          subtitle = default(rmarkdown::metadata$subtitle, "Subtitle"),
                          date = default(rmarkdown::metadata$date, cd_format_date(Sys.Date()))) {

  logo_path <- indiedown_path_tex("res/logo.png")

  indiedown_glue(
    # R >=4, raw strings allow to write LaTeX without escaping \ etc
    r"(
\vspace*{-1cm}
\begin{center}
  \makebox[\textwidth]{\includegraphics[width=0.1\paperwidth]{<<logo_path>>}}
\end{center}


\vspace*{2cm}

\noindent \Huge <<title>>

\noindent \huge <<subtitle>>

\vspace*{2cm}


\normalsize

\noindent <<date>>

\clearpage
    )"
  )
}

#' Corporate Design: knitr Chunk Options
#'
#' Set knitr chunk options in accordance with corporate design.
#'
#' @param twocolumn Use two-column mode? This will affect `fig.width` and `fig.height`.
#' @param fig.width Figure width. If `NULL`, automatically chosen based on `twocolumn`.
#' @param fig.height Figure height If `NULL`, automatically chosen based on `twocolumn`.
#' @param fig.pos Floating modifier for figures
#' @param message Should messages be shown?
#' @param echo Should echo be shown?
#' @return This function is called for its side effects and returns `NULL`, invisibly.
#' @examples
#' cd_knit_chunk_opts()
#'
#' @export
cd_knit_chunk_opts <- function(twocolumn = default(rmarkdown::metadata$twocolumn, FALSE),
                               fig.width = NULL,
                               fig.height = NULL,
                               fig.pos = "h",
                               message = FALSE,
                               echo = FALSE) {

  if (twocolumn) {
    fig.width <- default(fig.width, 4)
    fig.height <- default(fig.height, 3.5)
  } else {
    if (isTRUE(rmarkdown::metadata$wide)) {
      fig.width <- default(fig.width, 8.5)
      fig.height <- default(fig.height, 3.38)
    } else {
      fig.width <- default(fig.width, 7.25)
      fig.height <- default(fig.height, 3.5)
    }
  }
  knitr::opts_chunk$set(
    fig.width = fig.width,
    fig.height = fig.height,
    fig.pos = fig.pos,
    message = message,
    echo = echo
  )

  options(knitr.table.format = "latex")
  invisible()
}

#' Corporate Design: Format Date
#'
#' Format date in local language format
#'
#' @param date Current date
#' @param lang Language, either `"de-DE"`, `"de-CH"` or `"en_US"`
#' @return Character string, date in local format
#' @examples
#' cd_format_date("2012-01-01", "de-DE")
#' cd_format_date("2012-01-01", "en-US")
#' @export
cd_format_date <- function(date, lang = default(rmarkdown::metadata$lang, "en-US")) {
  date <- as.Date(date)
  if (lang %in% c("german", "de-DE", "de-CH")) {
    withr::with_locale(c("LC_TIME" = "de_DE"), format(date, "%e. %B %Y"))
  } else {
    withr::with_locale(c("LC_TIME" = "en_US"), format(date, "%B %e, %Y"))
  }
}

# indiedown: customize conditional settings here

pre_processor <- function(metadata, input_file, runtime, knit_meta, files_dir, output_dir) {

  # apply default.yaml (do not remove)
  args <- apply_default_yaml(metadata = metadata)

  # set the margin based on twocolumn and wide
  if (is.null(metadata$geometry)) {
    if (isTRUE(metadata$twocolumn) || isTRUE(metadata$wide)) {
      args <- c(args, "--variable", "geometry:top=1cm,bottom=1.75cm,left=2cm,right=2cm,includehead,includefoot")
    } else {
      args <- c(args, "--variable", "geometry:top=1cm,bottom=1.75cm,left=2.5cm,right=2.5cm,includehead,includefoot")
    }
  }

  args
}

---
title: "Customize Individual R Markdown Templates"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Customize Individual R Markdown Templates}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r setup}
library(indiedown)
```

## Assets

**Location:** `inst/indiedown` (folder)

Template assets are stored in a folder `inst/indiedown`.
This folder contains all the necessary information to customize your markdown template.
It can contain basic pandoc settings, additional LaTeX settings and dynamic pandoc settings.

### Basic Settings

**Location:** `default.yaml` (required)

`default.yaml` is the only required element of an indiedown template.
It specifies the default pandoc options used by your template.
To experiment with pandoc options, simply add them to the YAML header of a standard R Markdown document.

Most relevant LaTeX options can be set as pandoc options. For example, pandoc options allow you to set a customized font or a user defined geometry. If possible always prefer Pandoc options instead of LaTeX (covered below), as this will minimize unwanted interactions with other options.

For a detailed description of all pandoc options, see the 'Variables for LaTeX' section in the [pandoc Manual](https://pandoc.org/MANUAL.html#).

`default.yaml`, as well as `preamble.tex` supports substitution of the variable `<<indiedown_path>`, which is explained below.


### Additional LaTeX Settings

**Location:** `preamble.tex` (optional, advanced)

Sometimes, pandoc options are just not enough. While pandoc allows you to directly apply single LaTeX commands in the YAML header (using `headers-include`), `preamble.tex` offers a more convenient way to include LaTeX commands at the beginning of your document.

To include commands, simply edit `preamble.tex`.
Common options set in `preamble.tex` are the modification of section headings (e.g., `\usepackage[small]{titlesec}`), the provision of the `H` float modifier
(`\usepackage{float}`), or the packages used by [kableExtra](https://CRAN.R-project.org/package=kableExtra).

For most customizations, it is recommended to turn off the default LaTeX title page, using
`\renewcommand\maketitle{}`. Creating your own title page via LaTeX commands in the R Markdown script or by a customized R function is a much easier and more flexible way to create a customized title page.


### Dynamic Settings

**Location:** `pre_processor.R` (optional, advanced)

In a few cases, pandoc options should be set dynamically.
E.g., the geometry of a document should depend on whether it uses two columns or just one.
`pre_processor.R` allows you to dynamically modify pandoc options, using plain R.
See the example script for how to use it.


### Variable Substitution

`default.yaml`, as well as `preamble.tex` supports substitution of the variable `<<indiedown_path>`.
Whenever you mention `<<indiedown_path>` in one of your files, it will be substituted by the path to the `indiedown` folder.


### Including Additional Assets

Most customized styles will include some additional assets, such as a logo or a special font. Assets can be put into arbitrarily named folders. To access the assets from `default.yaml` or `preamble.tex`, simply use `<<indiedown_path>/res` and the path will be correctly resolved by indiedown.

## LaTeX Generators

Indiedown packages use R functions to generate LaTeX code for customization.

For most customizations, it is recommended to turn off the default LaTeX title page, and create your own title page via LaTeX commands. The basic repertory are the LaTeX commands `\large`, `\Large`, `\LARGE`, `\huge`, etc, along with `vspace{1ex}`, but all LaTeX trickery can be applied. The LaTeX helper functions should be put in the `R` folder of your package.


## Templates

R Markdown Templates demonstrate the use of a customized style. R Markdown requires you to put them in `inst/rmarkdown/templates/mytemplate`.
RStudio will recognize them and show them when you click 'New R Markdown Document' and 'from Template'.
You can also use `usethis::use_rmarkdown_template()` to add a new template.

---
title: "Walkthrough: Build your own R Markdown Template"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Walkthrough: Build your own R Markdown Template}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

`vignette("intro")` has shown how to set up a package skeleton with indiedown. This article teaches you how to apply customizations to produce a template that fits your needs.


## Customization points

indiedown does not modify the default `.tex` template of Pandoc. Instead, all modifications are applied on top of it.
This should make it compliant with future releases of Pandoc and R Markdown.

There are three possible customization points to customize an indiedown skeleton:

- Set defaults (such as fonts or geometry) in the YAML header at `inst/indiedown/default.yaml`

- Tweak LaTeX settings at `inst/indiedown/preamble.tex`

- Apply dynamic adjustments in `pre_processor.R` (advanced)

For this tutorial, we will focus on the first two points only.

## `default.yaml`

Let's have a look at `inst/indedown/default.yaml`:

```yml
# indiedown: customize defaults in YAML header here

indent: false
compact-title: true
subparagraph: true  # needed for titlesec
papersize: a4
documentclass: article
secnumdepth: 2
fontsize: "11pt"

mainfont: regular.ttf
mainfontoptions:
- Path=<<indiedown_path>>/fonts/
- BoldFont=bold.ttf
- ItalicFont=italic.ttf
- BoldItalicFont=bolditalic.ttf
- Scale=0.92

linestretch: 1.05

geometry:
- top=2cm
- bottom=2cm
- left=2cm
- right=2cm
```

These are simply defaults for the custom template. So rather than adding these options to the YAML header of the `.Rmd` each time, they can be stored centrally.
You can overwrite these values in the `.Rmd` file.

It is recommended to set as many customizations as possible as Pandoc options, and fall back to LaTeX if this is not possible.
A full list of options is given in the [LaTeX section of the Pandoc manual](https://pandoc.org/MANUAL.html#variables-for-latex).

In our case, we want to use slightly wider page margins, so we change the geometry to:

```yml
geometry:
- top=2.5cm
- bottom=2.5cm
- left=3cm
- right=3cm
```

## Changing Fonts

Changing the font to fit your corporate style is usually the first step in customization.

Note that `<<indiedown_path>>` will be automatically substituted with the actual location of `inst/indiedown`. That is why we can include *assets* that are picked up by the template. The default template includes the free Roboto font, which is located at `inst/indiedown`.

We could replace that with a proprietary font to match the corporate design.
Instead we use a helper function to get one of [Google's free fonts](https://fonts.google.com).

use_indiedown_gfonts(id = "lato")

The function relies on the [gfonts](https://CRAN.R-project.org/package=gfonts) package to download and install the *Lato* font.
If you don't know the ID of a font, use `gfonts::get_all_fonts()` to get a list of all available fonts.

Let's preview what we have by now:

![](fig/status-1.png){ width=70% }


## `preamble.tex`

Let's turn to the second customization point, `preamble.tex`. This contains LaTeX code that is run at the beginning. Add everything here that cannot be changed in the `default.yaml`. We want to use slightly bigger headers, and change the `titlesec` line to:

```tex
\usepackage[medium]{titlesec}
```

As for `default.yaml`, it supports substitution of `<<indiedown_path>>`, so you could link to images here as well. Generally, you do not want do too many thing here.
Note that the default LaTeX title page is disabled in the default template, for good reason:

```tex
\renewcommand\maketitle{}
```

Instead, we will build our own title page in R now.

## A customized title page.

One of the core principles of indiedown is to keep corporate design elements as R code. That way, elements can be arranged flexibly and adjusted to particular needs.

As a final step, we build a customized title page by modifying the function definition of `R/cd_page_title`. The function writes LaTeX code that will be added to the `.Rmd` when `cd_page_title()` is called.

To make writing of LaTeX code in R easy, we rely on the raw string feature that was added in R 4.0.0. It allows you to write pure LaTeX code in R, without having to escape every `\` by a second `\\`.

If you have to use a version of R that is older, the `read_tex()` function offers an alternative way to write unescaped LaTeX code. See `?read_tex`.

The `indiedown_glue()` helper function uses the [glue](https://CRAN.R-project.org/package=glue) package to substitute variables in the string. That way, variables such as `title` or `subtitle` will be substituted in the LaTeX code.

With `indiedown_path_tex()`, you can also refer to the path of `inst/indiedown`, and use assets from the package. In the example, we use this to include a logo. Now, we don't want to use a logo but rather a photograph of a beautiful parrot. We download the image from [unsplash.com](https://unsplash.com/photos/gGC63oug3iY) in medium quality and store it in `res/mikhail-vasilyev-gGC63oug3iY-unsplash.jpg`. Then, we change the function definition as follows:

```r
cd_page_title <- function(title = default(rmarkdown::metadata$title, "Title"),
                          subtitle = default(rmarkdown::metadata$subtitle, "Subtitle"),
                          date = default(rmarkdown::metadata$date, cd_format_date(Sys.Date()))) {

  img_path <- indiedown_path_tex("res/mikhail-vasilyev-gGC63oug3iY-unsplash.jpg")

  indiedown_glue(
    # R >=4, raw strings allow to write LaTeX without escaping \ etc
    r"(

\vspace*{-3cm}

\begin{center}
\makebox[\textwidth]{\includegraphics[width=\paperwidth]{<<img_path>>}}
\end{center}

\vspace*{2cm}

\noindent \Huge <<title>>

\noindent \huge <<subtitle>>

\vspace*{2cm}

\normalsize

\noindent <<date>>

\clearpage
    )"
  )
}
```

Of course, we could also pass an image path as an argument, so we can choose a different title page in each report.

Building the package again, and running the template `.Rmd`, we get:

![](fig/status-2.png){ width=30% }

## Where to go from here

indiedown provides a framework to easily generate customized R Markdown templates. Templates can be customized by the full power of Pandoc and LaTeX through various points of customization.

This walk-through introduced two of them.
For more details and a description of the third one, see `vignette("customize")`.

---
title: "Introduction to Indiedown"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Introduction to Indiedown}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

indiedown makes it easy to generate a customized R Markdown PDF template that follow the principles of your corporate design.

Start by installing indiedown:

```{r eval = FALSE}
install.packages("indiedown")
```

You can also install the development version from GitHub:

```{r eval = FALSE}
# install.packages("remotes")
remotes::install_github("cynkra/indiedown")
```

## Create an customized R Markdown template

```{r eval = FALSE}
# install.packages("devtools")
devtools::install_github("cynkra/indiedown")
```

To create your own customized R Markdown template, start by creating an indiedown template package, called `mydown` in this example.
Navigate to the directory where you want to create the package, then:

```{r eval = FALSE}
indiedown::create_indiedown_package("mydown")
```

This creates a package skeleton in the new `mydown` directory in the current working directory.
You can build *mydown*, using "Build and Reload" in the RStudio or via the command line, as follows:

```{r eval = FALSE}
devtools::install("mydown")
```

With *mydown* built and installed, our new template is available in RStudio (after a restart):

![](fig/rstudio.png){ width=50% }



## Customization points

indiedown does not modify the default `.tex` template of Pandoc. Instead, all modifications are applied on top of it.
This should make it compliant with future releases of Pandoc and R Markdown.

There are three possible customization points to customize an indiedown skeleton:

- Set defaults (such as fonts or geometry) in the YAML header at `inst/indiedown/default.yaml`

- Tweak LaTeX settings at `inst/indiedown/preamble.tex`

- Apply dynamic adjustments in `pre_processor.R` (advanced)

See the `vignette("customize")` for details.


## Corporate Design Elements

Indiedown packages use R functions to generate LaTeX code for customization.

For most customizations, it is recommended to turn off the default LaTeX title page and create your own title page via LaTeX commands. The basic repertory are the LaTeX commands `\large`, `\Large`, `\LARGE`, `\huge`, etc, along with `vspace{1ex}`, but all LaTeX trickery can be applied. The LaTeX helper functions should be put in the `R` folder of your package.

The function `cd_page_title()` creates an example title page that can be adjusted to your needs. Note that the example uses raw strings, which are only available in R >= 4. They make it easy to write LaTeX code directly in R. See details in `?indiedown_glue` for methods that work well with R < 4.


## Principles of Indiedown

### Extend Pandoc .tex, do not replace

indiedown does not modify the default `.tex` template of Pandoc. Instead, all modifications are applied on top of it.
This should make it compliant with future releases of Pandoc and R Markdown.

### Use R to customize

Keep all corporate design elements as R code. This keeps the LaTeX code simple and allows flexible extensions.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cd_knit_chunk_opts.R
\name{cd_knit_chunk_opts}
\alias{cd_knit_chunk_opts}
\title{Corporate Design: knitr Chunk Options}
\usage{
cd_knit_chunk_opts(
  twocolumn = default(rmarkdown::metadata$twocolumn, FALSE),
  fig.width = NULL,
  fig.height = NULL,
  fig.pos = "h",
  message = FALSE,
  echo = FALSE
)
}
\arguments{
\item{twocolumn}{Use two-column mode? This will affect \code{fig.width} and \code{fig.height}.}

\item{fig.width}{Figure width. If \code{NULL}, automatically chosen based on \code{twocolumn}.}

\item{fig.height}{Figure height If \code{NULL}, automatically chosen based on \code{twocolumn}.}

\item{fig.pos}{Floating modifier for figures}

\item{message}{Should messages be shown?}

\item{echo}{Should echo be shown?}
}
\value{
This function is called for its side effects and returns \code{NULL}, invisibly.
}
\description{
Set knitr chunk options in accordance with corporate design.
}
\examples{
cd_knit_chunk_opts()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/indiedown.R
\name{indiedown_path}
\alias{indiedown_path}
\alias{indiedown_path_tex}
\title{Path helpers}
\usage{
indiedown_path(...)

indiedown_path_tex(...)
}
\arguments{
\item{...}{Path components, passed on to \code{system.file()}.}
}
\value{
Character string, path to this package's indiedown assets
}
\description{
\code{indiedown_path()} creates a path to this package's indiedown assets,
located at \code{inst/indiedown}.

\code{indiedown_path_tex()} creates a path that is usable in LaTeX,
with all special characters escaped.
}
\examples{
indiedown_path()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/indiedown.R
\name{default}
\alias{default}
\title{Set Default Value}
\usage{
default(x, default = "")
}
\arguments{
\item{x}{Character string, or \code{NULL}}

\item{default}{If \code{x} is \code{NULL}, \code{default} is used.}
}
\value{
Character string
}
\description{
Set default value of an argument. If \code{x} is \code{NULL}, \code{default} is used.
}
\examples{
default(NULL)
default(NULL, "my default")
default("a string", "my default")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/indiedown_pdf_document.R
\name{mypackage}
\alias{mypackage}
\title{Customized R Markdown Document}
\usage{
mypackage(...)
}
\arguments{
\item{...}{Passed on to \code{\link[rmarkdown:pdf_document]{rmarkdown::pdf_document()}}.}
}
\value{
R Markdown output format to pass to \code{\link[rmarkdown:render]{rmarkdown::render()}}.
}
\description{
\code{mypackage()} is the main function of the mypackage package. Use as
\code{output: mypackage::mypackage} in the R Markdown YAML header.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cd_page_title.R
\name{cd_page_title}
\alias{cd_page_title}
\title{Corporate Design: Title Page}
\usage{
cd_page_title(
  title = default(rmarkdown::metadata$title, "Title"),
  subtitle = default(rmarkdown::metadata$subtitle, "Subtitle"),
  date = default(rmarkdown::metadata$date, cd_format_date(Sys.Date()))
)
}
\arguments{
\item{title}{Document title}

\item{subtitle}{Document subtitle}

\item{date}{Document creation date}
}
\value{
Object of class \code{"knit_asis"} (so that knitr will treat it as is). LaTeX code for title page.
}
\description{
Example function to generate a title page
}
\examples{
cd_page_title(
  title = "My Title",
  subtitle = "My Subtitle"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cd_format_date.R
\name{cd_format_date}
\alias{cd_format_date}
\title{Corporate Design: Format Date}
\usage{
cd_format_date(date, lang = default(rmarkdown::metadata$lang, "en-US"))
}
\arguments{
\item{date}{Current date}

\item{lang}{Language, either \code{"de-DE"}, \code{"de-CH"} or \code{"en_US"}}
}
\value{
Character string, date in local format
}
\description{
Format date in local language format
}
\examples{
cd_format_date("2012-01-01", "de-DE")
cd_format_date("2012-01-01", "en-US")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/indiedown.R
\name{indiedown_glue}
\alias{indiedown_glue}
\title{Glue LaTeX Code for Use in R Markdown}
\usage{
indiedown_glue(x, .open = "<<", .close = ">>")
}
\arguments{
\item{x}{Character, often as a raw string (\code{r"()"})}

\item{.open, .close}{The opening and closing delimiter.}
}
\value{
Object of class \code{"knit_asis"} (so that knitr will treat it as is). Usually LaTeX code.
}
\description{
Use the function to wrap literal LaTeX code in R. Use a raw string input
(\code{r"()"}) to automatically escape quotes and backslashes, as they are common
in LaTeX. Expressions enclosed by \verb{<<} and \verb{>>} will be evaluated as R code.
}
\details{
\code{indiedown_glue()} uses a different default than the underlying
\code{glue::glue()} (\verb{<<} and \verb{>>}), because braces are so common in LaTeX.
Doubling the full delimiter (\verb{<<<<} and \verb{>>>>}) escapes it.
}
\examples{
x <- "something"
indiedown_glue(r"(\LaTeX\ code with <<x>> substituted )")

}
